﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace DesignForTesting
{
    public class SeparatedDataReader : IDataReader
    {
        private TextReader _reader;
        private char _separator;
        private string[] _currentData;

        public SeparatedDataReader(TextReader reader, char separator)
        {
            if (reader == null)
            {
                throw new ArgumentNullException("reader");
            }
            _reader = reader;
            _separator = separator;
        }

        #region IDataReader Members

        public bool ReadNext()
        {
            string line = _reader.ReadLine();
            if (line != null)
            {
                _currentData = line.Split(_separator);
                return true;
            }
            else
            {
                return false;
            }
        }

        public int Count
        {
            get { return _currentData.Length; }
        }

        public string this[int index]
        {
            get { return _currentData[index]; }
        }

        #endregion
    }
}
