﻿using DesignForTesting;
using Microsoft.VisualStudio.TestTools.UnitTesting;
namespace TestsLibrary
{
    
    
    /// <summary>
    ///This is a test class for PersonTest and is intended
    ///to contain all PersonTest Unit Tests
    ///</summary>
    [TestClass()]
    public class PersonTest
    {
        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion

        /// <summary>
        ///A test for ToString
        ///</summary>
        [TestMethod()]
        public void ToStringTest()
        {
            string firstName = "Gabriele";
            string secondName = "Zannoni";
            string title = "Ing."; 
            Person target = new Person(firstName, secondName, title);
            string expected = "Ing. Gabriele Zannoni";
            string actual;
            actual = target.ToString();
            Assert.AreEqual<string>(expected, actual);
        }

        /// <summary>
        ///A test for Person Constructor
        ///</summary>
        [TestMethod()]
        public void PersonConstructorTest()
        {
            string firstName = "Gabriele";
            string secondName = "Zannoni";
            string title = "Ing.";
            Person target = new Person(firstName, secondName, title);
            Assert.AreEqual<string>(firstName, target.FirstName);
            Assert.AreEqual<string>(secondName, target.SecondName);
            Assert.AreEqual<string>(title, target.Title);
        }
    }
}
