﻿using DesignForTesting;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.IO;
using System;

namespace TestsLibrary
{
    
    
    /// <summary>
    ///This is a test class for SeparatedDataReaderTest and is intended
    ///to contain all SeparatedDataReaderTest Unit Tests
    ///</summary>
    [TestClass()]
    public class SeparatedDataReaderTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for Item
        ///</summary>
        [TestMethod()]
        public void ItemTest()
        {
            TextReader reader = new StringReader("Gabriele,Zannoni,Ing.");
            char separator = ',';
            SeparatedDataReader target = new SeparatedDataReader(reader, separator);
            target.ReadNext();
            Assert.AreEqual<string>("Gabriele", target[0]);
            Assert.AreEqual<string>("Zannoni", target[1]);
            Assert.AreEqual<string>("Ing.", target[2]);
        }

        /// <summary>
        ///A test for Count
        ///</summary>
        [TestMethod()]
        public void CountTest()
        {
            TextReader reader = new StringReader("Gabriele,Zannoni,Ing.");
            char separator = ',';
            SeparatedDataReader target = new SeparatedDataReader(reader, separator);
            target.ReadNext();
            Assert.AreEqual<int>(3, target.Count);
        }

        /// <summary>
        ///A test for ReadNext
        ///</summary>
        [TestMethod()]
        public void ReadNextTest()
        {
            TextReader reader = new StringReader("Gabriele,Zannoni,Ing.");
            char separator = ',';
            SeparatedDataReader target = new SeparatedDataReader(reader, separator);
            Assert.AreEqual<bool>(true, target.ReadNext());
            Assert.AreEqual<bool>(false, target.ReadNext());
        }

        /// <summary>
        ///A test for SeparatedDataReader Constructor
        ///</summary>
        [TestMethod()]
        [ExpectedException(typeof(ArgumentNullException))]
        public void SeparatedDataReaderConstructorTest()
        {
            TextReader reader = null;
            char separator = '\0';
            SeparatedDataReader target = new SeparatedDataReader(reader, separator);
        }
    }
}
